/* 
 * File:   BasicCollection.h
 * Author: daniel
 *
 * Created on August 22, 2010, 4:06 PM
 */

#ifndef _BASICCOLLECTION_H
#define	_BASICCOLLECTION_H

#include "../BodyCollection.h"
#include <vector>

using namespace std;
//---------------------BasicCollection---------------------
// This class implements the most basic collection and it's
// used for debugging or in scenes with a small number of bodies.
// It stores the bodies in an stl vector and searches through them
// one by one.
//---------------------------------------------------------
class BasicCollection : public BodyCollection {
public:
    BasicCollection() {}
    ~BasicCollection();

    void addBody(Body* body);
    //see parent for documentation of these functions
    int intersectRay(Ray& ray, Vector3d& interPoint, Vector3d& normal, Body*& body);
    bool hasIntersection(Ray& ray, double distSq) const;

private:
    vector<Body*> bodies;
};
#endif	/* _BASICCOLLECTION_H */

