/* 
 * File:   Common.h
 * Author: daniel
 *
 * Created on August 11, 2010, 8:09 PM
 */

#ifndef _COMMON_H
#define	_COMMON_H

#include "Eigen/Core"
#include <cmath>
//Define the eigen types we're going to be using
typedef Eigen::Matrix<double, 3, 1> Vector3d;
typedef Eigen::Matrix<int, 3, 1> Vector3i;
typedef Vector3d Color3d;
typedef Vector3i Color3i;

//------------------------isEqual--------------------------
// Checks if the difference between two numbers is within
// a limit
//---------------------------------------------------------
inline bool isEqual(double num1, double num2)
{
    return fabs(num1 - num2) < 1E-12;
}

//----------------------clipToInterval---------------------
// Gets a double and an interval as input and returns the point
// in the interval closest to the intereval
//---------------------------------------------------------
inline double clipToInterval(double num, double lowerBound, double upperBound)
{
    if (lowerBound > upperBound) return num;  //there was an error with the input so dont do anything
    if (num >= upperBound) return upperBound;
    if (num <= lowerBound) return lowerBound;
    return num;
}

#endif	/* _COMMON_H */

