#include "Plane.h"

//----------------------intersectRay-----------------------
// Compute intersection of ray and plane
//---------------------------------------------------------
int Plane::intersectRay(Ray& ray, Vector3d& interPoint, Vector3d& interNormal)
{
    double dot = (ray.getDirection()).dot(normal); //the dot product of the ray direction and the plane normal
    if (isEqual(dot, 0)) return 0; //the ray is paralel to the plane

    //the distance from the origin of the ray to the intersection point
    double dist = ((position - ray.getOrigin()).dot(normal)) / dot;
    if (dist < 0) return 0; //the ray is ontop of the plane

    //we have an intersection so compute the relavent variables
    interNormal = normal;
    interPoint = ray.getOrigin() + dist*ray.getDirection();

    if (dot > 0) return -1; //the ray hits from behind
    return 1; //the ray hits from infront
}
