/* 
 * File:   Plane.h
 * Author: daniel
 *
 * Created on September 3, 2010, 2:47 PM
 */

#ifndef _PLANE_H
#define	_PLANE_H

#include "../Geometry.h"

//---------------------------Plane------------------------
//This represents the plane geometry type.
//---------------------------------------------------------
class Plane : public Geometry {
public:
    Plane() : normal(Vector3d::Identity()) {};
    Plane(Vector3d position, Vector3d normal) : Geometry(position), normal(normal) {};

    Vector3d getNormal() const {return normal;}
    void setNormal(Vector3d normal){this->normal = normal.normalized();} //we normalize just to make sure

    int intersectRay(Ray& ray, Vector3d& interPoint, Vector3d& interNormal);
private:
    Vector3d normal;
};


#endif	/* _PLANE_H */

