/* 
 * File:   ImagePPM.h
 * Author: daniel
 *
 * Created on August 11, 2010, 7:58 PM
 */

#ifndef _IMAGEPPM_H
#define	_IMAGEPPM_H

#include "Common.h"
#include <string>
#include <fstream>
#include <vector>

using namespace std;
typedef vector< vector<Color3i> > Array2D;
//------------------ImagePPM-------------------
// This class reads and write to an image in the
// PPM format. The pixels are stored as Vectors
// and the image is stored as a std vector of vectors
// the top left corner is (0,0)
//---------------------------------------------
class ImagePPM{
public:
    ImagePPM();
    ImagePPM(int width, int height);

    void readPPM(string fileName);
    void writePPM(ostream& out);

    void setPixel(int width, int height, Color3i pixel);
    Color3i getPixel(int width, int height);

    void applyGamma(double gamma);

private:
     Array2D image;
    int width, height;
};

#endif	/* _IMAGEPPM_H */

