/* 
 * File:   Ray.h
 * Author: daniel
 *
 * Created on August 13, 2010, 5:23 PM
 */

#ifndef _RAY_H
#define	_RAY_H

#include "Common.h"
//---------------------------Ray---------------------------
//This class describes a ray which is simply a direction
//together with an origin.  The ray itself is simple and
//contains almost no calculations.  The direction should
//be normalized but this is the users choice and responsibility
//---------------------------------------------------------
class Ray{
public:
    Ray() : origin(Vector3d::Zero()), direction(Vector3d::Identity()) {};
    Ray(Vector3d origin, Vector3d direction) : origin(origin), direction(direction) {};

    Vector3d getOrigin() const {return origin;}
    Vector3d getDirection() const {return direction;}
    void setOrigin(Vector3d origin){this->origin = origin;}
    void setDirection(Vector3d direction){this->direction = direction;}

private:
    Vector3d origin;
    Vector3d direction;
};

#endif	/* _RAY_H */

