/* 
 * File:   main.cpp
 * Author: daniel
 *
 * Created on August 11, 2010, 9:49 PM
 */

//#include "Common.h"
#include "Geometry.h"
#include "Geometry/Sphere.h"
#include "Geometry/Plane.h"
#include "Material.h"
#include "Body.h"
#include "Scene.h"
#include "BodyCollection.h"
#include "BodyCollections/BasicCollection.h"
#include "Shaders/BasicShader.h"
#include <iostream>
#include <string>

using namespace std;

int main(int argc, char** argv) {
    Shader* shader = new BasicShader();
    BodyCollection* collection = new BasicCollection();

    Geometry* sphere1 = new Sphere(Vector3d(3.0,28.5,0), 3);
    Body* body1 = new Body();
    body1->setGeometry(sphere1);
    body1->getMaterial()->setColor(Color3d(0.8,0.4,0.1));
    body1->getMaterial()->setDiffuse(0.5);
    body1->getMaterial()->setReflection(0.7);
    body1->getMaterial()->setShininess(10);
    //collection->addBody(body1);

    Geometry* sphere2 = new Sphere(Vector3d(-3,10,-2), 3);
    Body* body2 = new Body();
    body2->setGeometry(sphere2);
    body2->getMaterial()->setColor(Color3d(0.8,0.8,0.8));
    body2->getMaterial()->setDiffuse(0.1);
    body2->getMaterial()->setReflection(0.0);
    body2->getMaterial()->setRefraction(1.0);
    body2->getMaterial()->setRefractIndex(1.33);
    body2->getMaterial()->setShininess(10);
    //collection->addBody(body2);

    Geometry* sphere3 = new Sphere(Vector3d(-1,9,3), 2);
    Body* body3 = new Body();
    body3->setGeometry(sphere3);
    body3->getMaterial()->setColor(Color3d(0.3,0.4,0.9));
    body3->getMaterial()->setDiffuse(0.3);
    body3->getMaterial()->setReflection(0.8);
    body3->getMaterial()->setShininess(15);
    //collection->addBody(body3);

    Geometry* sphere5 = new Sphere(Vector3d(-2.5,30,-2.5), 2.0);
    Body* body5 = new Body();
    body5->setGeometry(sphere5);
    body5->getMaterial()->setColor(Color3d(0.3,0.9,0.4));
    body5->getMaterial()->setDiffuse(0.9);
    body5->getMaterial()->setReflection(0.0);
    body5->getMaterial()->setShininess(5);
    //collection->addBody(body5);

    Geometry* plane1 = new Plane(Vector3d(0,0,-5.0), Vector3d(0,0,1));
    Body* body4 = new Body();
    body4->setGeometry(plane1);
    body4->getMaterial()->setColor(Color3d(0.7,0.7,0.7));
    body4->getMaterial()->setDiffuse(1.0);
    body4->getMaterial()->setReflection(0.0);
    body4->getMaterial()->setShininess(5);
    //collection->addBody(body4);

    Scene* scene = new Scene(collection, shader);

    Light* light1 = new Light(Color3d(0.6,0.6,0.6), Vector3d(-2.0, -10.0, 10.0));
    //Light* light2 = new Light(Color3d(1.0,1.0,1.0), Vector3d(20.0, 5.0, 50.0));
    Light* light2 = new Light(Color3d(0.6,0.6,0.6), Vector3d(-2, -11.0, 9.0));

    //scene->addLight(light1);
   // scene->addLight(light2);
    std::cout<<"loading...";
    scene->loadConfigFile("ray_config.lua");

    scene->generateImage();

    return (EXIT_SUCCESS);
}

